<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:p="http://primefaces.org/ui">




    <s:div id="resultDiv" styleClass="row">
        <s:div styleClass="col-lg-6"
               rendered="#{messageBean.message.getResultOid()!=null and !(messageBean.message.getResultOid().isEmpty())}">
            <h:form>
                #{dataTableStateHolder.setDescendingOn('oid')}
                <rich:dataTable id="resultTable" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                value="#{messageBean.message.getResultOid()}" var="oid" render="resultDS">
                    <f:facet name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.ValidationResult']}"/>
                    </f:facet>
                    <g:column sortBy="#{oid}"
                              sortOrder="#{dataTableStateHolder.sortOrders['oid']}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['net.ihe.gazelle.proxy.ValidationResultOid']}"/>
                        </ui:define>
                        <h:outputLink target="_blank" value="#{messageBean.getValidationPermanentLink(oid)}">
                            <h:outputText value="#{oid}"/>
                        </h:outputLink>
                    </g:column>
                    <rich:column>
                        <f:facet name="header">
                            <h:outputText value="#{messages['net.ihe.gazelle.proxy.ValidationResultDate']}"/>
                        </f:facet>
                        <h:outputText value="#{messageBean.getValidationDate(oid)}"/>
                    </rich:column>
                    <rich:column>
                        <f:facet name="header">
                            <h:outputText value="#{messages['net.ihe.gazelle.proxy.ValidationResultStatus']}"/>
                        </f:facet>
                        <h:outputText value="#{messageBean.getValidationStatus(oid)}"/>
                    </rich:column>
                    <rich:column>
                        <f:facet name="header">
                            <h:outputText value="#{messages['net.ihe.gazelle.proxy.Action']}"/>
                        </f:facet>
                        <a4j:commandLink
                                value="#{messages['net.ihe.gazelle.proxy.RemoveThisValidationResult']}"
                                action="#{messageBean.removeResult(oid)}"
                                actionListener="#{messageBean.retrieveMessage2()}"
                                render="resultDiv"/>
                    </rich:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="resultDS"/>
                            <ui:param name="dataTableId" value="resultTable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </h:form>
        </s:div>
    </s:div>

    <s:decorate template="/layout/panels/_panel_title.xhtml"
                rendered="#{messageBean.shouldDisplayMessageContent() or messageBean.isDownloadable()}">
        <ui:define name="panel_title">
            <h:outputText value="#{messages['net.ihe.gazelle.proxy.MessageContent']}"/>
        </ui:define>
        <h:panelGroup rendered="#{messageBean.isDownloadable() and !messageBean.isErrorMessage()}">
            <p>
                <h:form>
                    <dl class="dl-horizontal">

                        <h:panelGroup>
                            <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                <s:div styleClass="col-sm-3">
                                    <span class="gzl-icon-download"/>
                                    <h:commandButton action="#{messageBean.downloadFile(false,messageBean.message)}"
                                                     value="#{messages['net.ihe.gazelle.proxy.DownloadFile']}"
                                                     execute="@this" immediate="true" styleClass="gzl-btn-blue"/>
                                </s:div>
                                <s:div styleClass="col-sm-3">
                                    <span class="gzl-icon-search"/>
                                    <h:commandButton action="#{messageBean.downloadFile(true,messageBean.message)}"
                                                     value="#{messages['net.ihe.gazelle.proxy.ViewInline']}"
                                                     execute="@this" immediate="true" styleClass="gzl-btn-blue"/>
                                </s:div>
                                <s:div styleClass="col-sm-3" rendered="#{not messageBean.isMultipart()}">
                                    <span class="gzl-icon-checked"/>
                                    <h:commandButton action="#{messageBean.validate(messageBean.message)}"
                                                     value="#{messages['net.ihe.gazelle.proxy.ValidateUsingEVSClient']}"
                                                     execute="@this" immediate="true" styleClass="gzl-btn-green"/>
                                </s:div>
                            </ui:decorate>
                        </h:panelGroup>
                    </dl>
                    <h:panelGroup rendered="#{messageBean.isMultipart()}">
                        <span class="gzl-icon-exclamation-triangle"/><span>#{messages['net.ihe.gazelle.proxy.CannotValidateEntireMultipartMessagesPleaseUseEV']}</span>
                    </h:panelGroup>
                    <s:span id="displayButtons" rendered="#{messageBean.isRawMessage()}">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.proxy.DisplayText']}"
                                           styleClass="gzl-btn btn-xs" execute="@this"
                                           action="#{messageBean.setDisplayInText(true)}"
                                           render="insertForm,displayButtons"
                                           rendered="#{!messageBean.isDisplayInText()}"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.proxy.DisplayHexdump']}"
                                           styleClass="gzl-btn btn-xs" execute="@this"
                                           action="#{messageBean.setDisplayInText(false)}"
                                           render="insertForm,displayButtons"
                                           rendered="#{messageBean.isDisplayInText()}"/>
                    </s:span>
                </h:form>
            </p>
        </h:panelGroup>

        <h:form id="insertForm">
            <h:panelGroup rendered="#{messageBean.shouldDisplayHL7MessageContent()}">
                <pre><h:outputText value="#{messageBean.message.getMessageReceivedAsString()}"/></pre>
            </h:panelGroup>
            <h:panelGroup rendered="#{!messageBean.shouldDisplayHL7MessageContent()}">
                <div style="font-family: monospace;" class="well">
                    <s:div id="id1">
                        <gdk:insert rendered="#{messageBean.shouldDisplayMessageContent()}"
                                    content="#{messageBean.prettyFormat(messageBean.message.getMessageReceivedAsString())}"
                                    highlight="xml"/>
                    </s:div>
                    <s:div id="id2">
                        <p:accordionPanel widgetVar="multiple" var="item" value="${messageBean.separateDicomMessageAsXMLStringList()}" multiple="true"
                                          rendered="#{messageBean.shouldDisplayMtomMessageContent()}">
                            <p:tab title="Message DICOM Part ${(messageBean.separateDicomMessageAsXMLStringList().indexOf(item)+1)}">
                                <gdk:insert
                                        content="#{item}"
                                        highlight="xml"/>
                            </p:tab>
                        </p:accordionPanel>
                        <p:accordionPanel widgetVar="basic" rendered="#{messageBean.shouldDisplayMtomMessageContent()}"
                        >
                            <p:tab title="Message">
                                <gdk:insert
                                        content="#{messageBean.prettyFormat(messageBean.message.getMessageReceivedAsString())}"
                                        highlight="xml"/>
                            </p:tab>
                        </p:accordionPanel>
                    </s:div>
                    <s:div id="id4">
                        <gdk:insert rendered="#{messageBean.shouldDisplayDicomMessageContent()}"
                                    content="#{messageBean.message.getDicomMessageReceivedAsString()}"/>
                    </s:div>
                    <s:div id="id5">
                        <h:outputText id="text"
                                      value="#{messageBean.message.getDumpInText()}"
                                      rendered="#{messageBean.isDisplayInText() and messageBean.isRawMessage()}"/>
                    </s:div>
                    <s:div id="id6">
                        <gdk:insert rendered="#{messageBean.shouldDisplayRawMessageContent()}"
                                    content="#{messageBean.message.getRawMessageReceivedAsString()}"
                                    highlight="beanshell"/>
                    </s:div>
                    <s:div id="id7">
                        <h:outputText value="#{messageBean.message.getMessageReceivedAsString()}"
                                      style="white-space: pre-wrap;"
                                      rendered="#{messageBean.isErrorMessage()}"/>
                    </s:div>
                </div>
            </h:panelGroup>
        </h:form>

    </s:decorate>

</ui:composition>
